{-# OPTIONS_GHC -fglasgow-exts -fallow-overlapping-instances -fallow-undecidable-instances #-}
module Hawl.HaskellDB.DatabaseT (Database,DatabaseT, MonadDatabase(..), 
                                 runDatabaseT) where

import Control.Monad.Reader

import Database.HaskellDB

newtype DatabaseT m a = DatabaseT { unDatabaseT :: ReaderT Database m a }
    deriving (Functor, Monad, MonadTrans, MonadIO)

class MonadIO m => MonadDatabase m where
    getDB :: m Database

instance MonadIO m => MonadDatabase (DatabaseT m) where
    getDB = DatabaseT ask

instance (MonadTrans t, MonadDatabase m, MonadIO (t m)) 
    => MonadDatabase (t m) where
    getDB = lift getDB

runDatabaseT :: DatabaseT m a -> Database -> m a
runDatabaseT = runReaderT . unDatabaseT
