module Hawl.Session.DBDesc (createModules,createTables) where

import Database.HaskellDB
import Database.HaskellDB.DBSpec
import Database.HaskellDB.DBSpec.DBSpecToDBDirect


session_db = DBInfo {dbname = "session_db", 
                     opts = DBOptions {useBString = False}, 
                     tbls = session_tables}

session_tables = [sessions_meta_tbl,sessions_tbl]

sessions_meta_tbl =
    TInfo {tname = "sessions_meta",
           cols = [CInfo {cname = "max_age", descr = (IntT,False)},
                   CInfo {cname = "max_idle", descr = (IntT,False)}]}

sessions_tbl = 
    TInfo {tname = "sessions",
           cols = [CInfo {cname = "sessionid", descr = (IntT,False)},
                   CInfo {cname = "userid", descr = (IntT,True)},
                   CInfo {cname = "started", descr = (CalendarTimeT,False)},
                   CInfo {cname = "last_use", descr = (CalendarTimeT,False)}]}

createModules :: IO ()
createModules = dbInfoToModuleFiles "." "Hawl.Session.DB" session_db

createTables :: Database -> IO ()
createTables db = dbSpecToDatabase db session_db
