module Hawl.User.DBDesc  (createModules,createTables) where

import Database.HaskellDB
import Database.HaskellDB.DBSpec
import Database.HaskellDB.DBSpec.DBSpecToDBDirect


user_db = DBInfo {dbname = "user_db", 
                  opts = DBOptions {useBString = False}, 
                  tbls = user_tables}

user_tables = [users_meta_tbl,users_tbl]

users_meta_tbl =
    TInfo {tname = "users_meta",
           cols = [CInfo {cname = "next_userid", descr = (IntT,False)}]}

users_tbl = 
    TInfo {tname = "users",
           cols = [CInfo {cname = "userid", descr = (IntT,False)},
                   CInfo {cname = "username", descr = (BStrT 255,False)},
                   CInfo {cname = "password", descr = (BStrT 255,False)}]}

createModules :: IO ()
createModules = dbInfoToModuleFiles "." "Hawl.User.DB" user_db

createTables :: Database -> IO ()
createTables db = dbSpecToDatabase db user_db
