module Hawl.Util.XHtml where

import Text.XHtml

import Data.List (intersperse)

hlink :: HTML a => URL -> a -> Html
hlink u b = anchor ! [href u] << b

divc :: HTML a => String -> a -> Html
divc c b = thediv ! [theclass c] << b

spanc :: HTML a => String -> a -> Html
spanc c b = thespan ! [theclass c] << b

cssLink :: URL -> Html
cssLink url = 
    thelink ! [href url, rel "stylesheet", thetype "text/css"] << noHtml

javascript :: URL -> Html
javascript s = tag "script" ! [src s, thetype "text/javascript"] << noHtml

inlineJavascript :: String -> Html
inlineJavascript s = tag "script" ! [thetype "text/javascript"] << primHtml s

joinHtml :: [Html] -> Html
joinHtml = concatHtml . intersperse (toHtml " ")

mkHtml :: (HTML a,HTML b) => a -> b -> Html
mkHtml hdr bdy = (header << hdr) +++ (body << bdy)
